; Patch by Conn
; apply on Demon's Crest (U) without header expanded to min 2.5 MB


; $0F00 track number
; $0f02 msu busy
; $0f04 volume control
; $0f06 fade busy

; header ; remove semicolons before "header" if your rom has a header


lorom

org $829B3a ;expansion crack
db $80

org $bee35d ; expansion crack
db $80

org $80BC97
JML musicChange
NOP

org $808334
JSL nmiHook

org $80bd92
JSL SFX

org $c08000
musicChange:
LDY #$FA
PHA
LDA $2002      ;check if msu found
CMP #$53               
BEQ msufound
PLA   
JML $80BB82           ; spc is played
msufound:
PLA
PHA
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$01
STA $0f02  ; msu busy flag
PLA 
STA $0f00 ; save track number
LDY #$F9 ; mute
JML $80BB82 

nmiHook:
SEP #$30
LDA #$81
PHA
PLB
LDA $0f06
bne fadecontrol
LDA $0f02
bne $03
end:
LDA #$81
RTL
bit $2000
bvs end
PHX
LDA $0f00
TAX
lda #$FF   ; lautstrke
sta $2006
sta $0f04
lda $c08300,x
sta $2007
PLX
stz $0f02
bra end

fadecontrol:
cmp #$fe ; full volume
beq fe
cmp #$ff ; half volume
beq ff
cmp #$f1 ; no volume
beq f1
cmp #$76 ; dragon fight special
beq boss
cmp #$3e ; first boss fight special
beq boss
cmp #$3f ;organ
beq boss
cmp #$12 ;fire
beq boss
cmp #$70 ;headbutt game
beq boss

fe:
lda $0f04
cmp #$fb
bcs ffe
inc
inc
inc
cmp #$fb
bcs ffe
sta $2006
sta $0f04
LDA #$81
RTL
ffe:
lda #$FF
sta $2006
sta $0f04
stz $0f06
LDA #$81
RTL

ff:
lda $0f04
cmp #$30
bcc fff
dec
dec
dec
cmp #$30
bcc fff
sta $2006
sta $0f04
LDA #$81
RTL
fff:
lda #$30
sta $2006
sta $0f04
stz $0f06
LDA #$81
RTL

f1:
lda $0f04
cmp #$10
bcc ff1
dec
dec
dec
cmp #$10
bcc ff1
sta $2006
sta $0f04
LDA #$81
RTL
ff1:
lda #$00
sta $2006
sta $0f04
stz $0f06
LDA #$81
RTL

boss:
bit $2000
bvs end76
PHX
TAX
lda #$FF   ; lautstrke
sta $2006
sta $0f04
lda $c08300,x
sta $2007
PLX
stz $0f06
end76:
LDA #$81
RTL

SFX:
SEP #$30
LDY #$00
PHA
LDA $2002      ;check if msu found
CMP #$53               
BEQ $02
PLA
RTL
LDA $0f00
CMP #$2b
BNE continue
PLA
bra skip
continue:
cmp #$12
BNE continue1
PLA
cmp #$fb
bne noorgan
LDA #$3f      ;load organ
sta $0f06
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$f2
noorgan:
cmp #$f6
bne $03
jmp intro2
cmp #$f4
bne $03
jmp intro3
cmp #$f1
bne $03
jmp intro3
bra end2
continue1:
LDA $008d
cmp #$22
bne continue2
PLA 
bra skip
continue2:
PLA
cmp #$f1
bne $03
sta $0f06
cmp #$fe
bne $03
sta $0f06
cmp #$ff
bne $03
sta $0f06
skip:
cmp #$f2
bne nof2
lda $0f00
cmp #$2b
beq $03
stz $2007
LDA #$f2
nof2:
cmp #$fb
bne end2
STZ $2006      ; mute old track
lda $0f00
STA $2004   ; save track
STZ $2005
LDA #$01
STA $0f02  ; msu busy flag
LDA #$f2
end2:
; special sfx
PHA
LDA $0f00
cmp #$2b  ; no special sfx changes in ending
BNE $03
PLA
BRA end5
PLA
cmp #$76 ;first dragon fight sfx pcm 118
bne end3
LDA $0f00; don't play it at other places
CMP #$14
BEQ $04
LDA #$76
bra end3
LDA #$76
sta $0f06
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$f2
end3:
cmp #$3e ;first boss fight sfx pcm 62
bne end4
sta $0f06
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$f2
end4:
cmp #$70 ;headbutt game
bne end5
LDA $0f00; don't play it at other places
CMP #$26
BEQ $04
LDA #$70
bra end5
LDA #$70
sta $0f06
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$f2
end5:
cmp #$01 ;disable fire sfx at intro
beq $01
RTL
LDA $0f00
cmp #$12
BEQ $03
LDA #$01
RTL
LDA $7e1d81
cmp #$00
BEQ $03
LDA #$01
RTL
LDA #$12     ; play flames
sta $0f06
STZ $2006      ; mute old track
STA $2004   ; save track
STZ $2005
LDA #$f2
RTL

intro2:
lda $0f08
cmp #$3f
beq endIntro
LDA #$3f
sta $0f06
sta $0f08
STZ $2006
STA $2004   ; save track
STZ $2005
LDA #$f6
RTL

endIntro:
stz $0f08
stz $2007
RTL

intro3:
STZ $2007
RTL

ORG $c08300 ; loop table 03:loop, 01 non-loop
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f 
db $03,$01,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 10-1f
db $03,$03,$03,$01,$01,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03,$03 ; themes 20-2f
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01 ; themes 30-3f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 40-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 50-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 60-6f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 70-7f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 80-8f 	